(function($) {
// @link https://derekspringer.wordpress.com/2015/05/07/using-the-wordpress-media-loader-in-the-front-end/
$(document).ready( function() {
	
	var file_frame; // variable for the wp.media file_frame
	
	// attach a click event (or whatever you want) to some element on your page
	$( '#frontend-button' ).on( 'click', function( event ) {
		event.preventDefault();

        // if the file_frame has already been created, just reuse it
		if ( file_frame ) {
			file_frame.open();
			return;
		} 
		file_frame = wp.media.frames.file_frame = wp.media({
			title: $( this ).data( 'uploader_title' ),
			button: {
				text: $( this ).data( 'uploader_button_text' ),
			},
			multiple: false // set this to true for multiple file selection
		});

		file_frame.on( 'select', function() {
			attachment = file_frame.state().get('selection').first().toJSON();

			// do something with the file here
			$( '#frontend-button' ).hide();
			$( '#frontend-remove-button' ).show();
			$( '#frontend-image' ).attr('src', attachment.url);
			$( '#topic-image-id' ).val( attachment.id);
		});

		file_frame.open();
	});
	$( '#frontend-remove-button' ).on( 'click', function( event ) {
		event.preventDefault();
		// do something with the file here
		$( '#frontend-button' ).show();
		$( '#frontend-remove-button' ).hide();
		$( '#frontend-image' ).attr('src','');
		$( '#topic-image-id' ).val('');
		
	});
	$("#topic_category").on("change",function(){
		if($(this).val()=="new"){
			$("#new_topic_category").show();
		} else {
			$("#new_topic_category").val("");
			$("#new_topic_category").hide();
		}
	});
	
	// Follower AJAX
	$("#ctdb-follow-checkbox").on("change",function(){
		var ischecked = $(this).is(":checked");
		$.ajax({
			type: "POST",
			url: ajax_object.ajaxurl,
			data: {
				postid: ajax_object.postid,
				userid: ajax_object.userid,
				checked: ischecked,
				action: 'update_follow_status',
				security: $('#follow_update_nonce').val()
			},
			success: function(response){
				if(response>-1){
					$('.ctdb-follower-count span').html(parseInt(response));
				}
			}
		})
	});
	$(".ctdb-follow-button").on("click",function(){
		var ischecked = 'true';
		if( $(this).hasClass('ctdb-is-following') ) {
			ischecked = 'false';
		}
		$.ajax({
			type: "POST",
			url: ajax_object.ajaxurl,
			data: {
				postid: ajax_object.postid,
				userid: ajax_object.userid,
				checked: ischecked,
				action: 'update_follow_status',
				security: $('#follow_update_nonce').val()
			},
			success: function(response){
				$(".ctdb-follow-button").toggleClass('ctdb-is-following');
				if(response>-1){
					$('.ctdb-follower-count span').html(parseInt(response));
				}
			}
		})
	});
	// Status select
	$("#ctdb-status-select").on("change",function(){
		var select = $(this);
		select.fadeOut();
		$.ajax({
			type: "POST",
			url: ajax_object.ajaxurl,
			data: {
				postid: ajax_object.postid,
				userid: ajax_object.userid,
				new_status: select.val(),
				action: 'update_topic_status',
				security: $('#topic_status_nonce').val()
			},
			success: function(response) {
				select.fadeIn();
			}
		});
	});
	
	// Follow/unfollow board
	$(".ctdb-follow-board").on("click",function(e){
		e.preventDefault();
		var link = $(this);
		link.css('pointer-events','none');
		var following = link.data('action');
		var board_id = link.data('board');
		$.ajax({
			type: "POST",
			url: ajax_object.ajaxurl,
			data: {
				boardid: board_id,
				userid: ajax_object.userid,
				following: following,
				action: 'update_board_follow_status',
				security: $('#board_follow_nonce_'+board_id).val()
			},
			success: function(response){
				link.css('pointer-events','auto');
				// Response should be either follow or unfollow
				if(response=='follow'){
					link.html(ajax_object.unfollow_board);
					link.data('action','unfollow');
				} else if(response=='unfollow'){
					link.html(ajax_object.follow_board);
					link.data('action','follow');
				}
			}
		});
	});
	
	
	
	// Enable Timeago on freshness fields
	$(".ctdb-freshness-timeago time.timeago").timeago();
	// Enable Timeago on other date elements, like comment and post dates
	$(".ctdb-standard-timeago time.comment-timeago").timeago();
	
});

})(jQuery);